package ROM;
import java.io.*;
import java.util.*;

/** This represents the <B>EnumerationValue</B> object
 * @author <I> Brandon Morel </I>
 * (morel@ittc.ku.edu)
 */

public class EnumerationValue 
    extends Expression {
    
    Type type=null;
    ExpressionList elements=null;
    
    //changed the type of param from Item to BaseObject
    /** The primary constructor
     * @param parent The BaseObject parent of an object of this class
     * @param typeIn The type of the elements in the enumeration
     * @param elementsIn The list of the elements of the enumeration
     * @return Not applicable
     */
    public EnumerationValue(BaseObject parent, Type typeIn, 
			    ExpressionList elementsIn) {
	super(parent);
	type = typeIn;
	elements = elementsIn;
    }
	
    /** The secondary constructor
     * @param parent The BaseObject parent of an object of this class
     * @return Not applicable
     */
    public EnumerationValue(BaseObject parent) {
	super(parent);
    }

    /** To retrieve element type
     * @return Type representing the type of elements in the enumeration
     */
    public Type getType(){
	return type;
    }

    /** To return the enumeration
     * @return ItemList The list representing the enumeration
     */
    public ExpressionList getElements(){
	return elements;
    }


    /**To set the type
     * @param Type
     * @return void
     */
    public void setType(Type typeIn){
	type = typeIn;
    }

    /**To set the elements
     * @param ItemList
     * @return void
     */
    public void setElements(ExpressionList itemIn){
	elements = itemIn;
    }

    /** To get the string representation of the object
     * @return String representing the string of this object
     */
    public String toString() {
	return null;
    }

    /** For cases when value references an item.
     * Irrelevant here.
     */
    public LabelledItem labelLookup(Label label2){
	return null;
    }
	
    public void publishROM(PrintWriter pw){
	pw.print("[");
	ListIterator exprIter = getElements().listIterator();
	if (exprIter != null){
	    while (exprIter.hasNext()){
		Expression expr = (Expression)exprIter.next();
		if (expr != null)
		    expr.publishROM(pw);
	    }
	}
	pw.print("]");
    }
	
}

		


