//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Srinivas akki@ittc.ukans.edu
//
// 
//  $Id: ExpressionList.java,v 1.2 2000/12/03 23:59:45 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: ExpressionList.java,v $
//  Revision 1.2  2000/12/03 23:59:45  cvs
//  Added the new types of array, set and sequence. The methods getType  and alreadyDeclared are also added to get a type that has been previously declared.
//  --srinivas
//
//  Revision 1.1  2000/10/30 22:32:51  cvs
//  The ExpressionList class is added
//  --srinivas
//
//=============================================================================
package ROM;

/** This represents the <B>ExpressionList</B> object
 * @author <I> Cindy Kong and Srinivas Akkipeddi </I>
 * (ckong@ittc.ukans.edu, akki@ittc.ukans.edu)
 */
public class ExpressionList
extends List {

	/** The primary Constructor
	 * @return Not applicable
	 */
	public ExpressionList() {
		super();
	}

	/** To add an Expression
	 * @param expr The Expression to add
	 * @return void
	 */
	public void addItem (Expression expr) {
		addElement(expr);
	}

	/** To remove an Expression
	 * @param expr The BaseObject to remove
	 * @return void
	 */
	public void removeItem (Expression expr) {
		removeElement(expr);
	}

	/** To retrieve the first item in the list
	 * @return Expression representing the first item
	 */
	public Expression firstItem() {
		return (Expression)first();
	}

	/** To retrieve the last item in the list
	 * @return Expression representing the last object in the list
	 */
	public Expression lastItem() {
		return (Expression)last();
	}

	/** To check if list contains a specific item
	 * @param expr Expression present or not in list
	 * @return boolean, true if item present, false otherwise
	 */
	public boolean containsItem(Expression expr) {
		return containsElement(expr);
	}

}
		

