//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Cindy ckong@ittc.ukans.edu
//           David schond@ittc.ukans.edu
//
//  $Id: ItemReferenceList.java,v 1.2 2000/08/10 01:04:12 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: ItemReferenceList.java,v $
//  Revision 1.2  2000/08/10 01:04:12  cvs
//  All object in ROM has a parent, therefore implemented the constructors
//  to take in a BaseObject parent.
//  -- Cindy
//
//  Revision 1.1  2000/08/09 23:03:10  cvs
//  Dropped the ROM_ prefix on all files; dumped getElt() method from
//  List.java, made Universe a subclass of BaseObject. --David 
//
//  Revision 1.1  2000/08/09 04:29:53  cvs
//  The data structures for the files I have added are more or less
//  complete. For several of the classes no implementation has been given
//  yet. Their presence gives an idea of the inheritance hierarchy.
//  -- Cindy
//
//
//
//=============================================================================
package ROM;

/** This represents the <B>ItemReferenceList</B> object
 * @author <I> Cindy Kong and David Schonberger </I>
 * (ckong@ittc.ukans.edu, schond@ittc.ukans.edu)
 */
public class ItemReferenceList
extends List {

	/** The primary Constructor
	 * @return Not applicable
	 */
	public ItemReferenceList() {
		super();
	}

	/** To add an itemReference
	 * @param itemReference The ItemReference to add
	 * @return void
	 */
	public void addItemReference (ItemReference itemReference) {
		addElement(itemReference);
	}

	/** To remove an itemReference
	 * @param itemReference The BaseObject to remove
	 * @return void
	 */
	public void removeItemReference (ItemReference itemReference) {
		removeElement(itemReference);
	}

	/** To retrieve the first referenceItem in the list
	 * @return ReferenceItem representing the first referenceItem
	 */
	public ItemReference firstItemReference() {
		return (ItemReference)first();
	}

	/** To retrieve the last itemReference in the list
	 * @return ItemReference representing the last object in the list
	 */
	public ItemReference lastItemReference() {
		return (ItemReference)last();
	}

	/** To check if list contains a specific itemReference
	 * @param itemReference ItemReference present or not in list
	 * @return boolean, true if itemReference present, false otherwise
	 */
	public boolean containsItemReference(ItemReference itemReference) {
		return containsElement(itemReference);
	}

}
		

