//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Srinivas akki@ittc.ukans.edu
//
// 
//  $Id: TypeList.java,v 1.1 2000/12/03 23:59:46 cvs Exp $
//
//
//=============================================================================
package ROM;
import java.io.*;
import java.util.*;
/** This represents the <B>TypeList</B> object
 * @author <I> Cindy Kong and Srinivas Akkipeddi </I>
 * (ckong@ittc.ukans.edu, akki@ittc.ukans.edu)
 */
public class TypeList
extends List {

	/** The primary Constructor
	 * @return Not applicable
	 */
	public TypeList() {
		super();
	}

	/** To add an Type
	 * @param type The type to add
	 * @return void
	 */
	public void addItem (Type type) {
		addElement(type);
	}

	/** To remove an Type
	 * @param type The type to remove
	 * @return void
	 */
	public void removeItem (Type type) {
		removeElement(type);
	}

	/** To retrieve the first item in the list
	 * @return Type representing the first item
	 */
	public Type firstItem() {
		return (Type)first();
	}

	/** To retrieve the last item in the list
	 * @return Type representing the last object in the list
	 */
	public Type lastItem() {
		return (Type)last();
	}

	/** To check if list contains a specific item
	 * @param expr Expression present or not in list
	 * @return boolean, true if item present, false otherwise
	 */
	public boolean containsItem(Type type) {
		return containsElement(type);
	}

	/**To check if the array or set or sequence of the type already
	 * exsists
	 * @param type To know if it is a array, set or sequence
	 * @param elementType To search for the element type
	 * @return Type 
	 */
	public Type alreadyDeclared(String type, Type elementType){
		ListIterator listIter = this.listIterator();
		Type result = null;
		if (listIter != null){
			while (listIter.hasNext()){
				Type element = (Type)listIter.next();
				if (type.equals("array")){
					if ((element instanceof ArrayType) &&
						(((ArrayType)element).getElementType().toString().
						 equals(elementType.toString()))){
						result = element;
						break;
					}
				}else if (type.equals("set")){
					if ((element instanceof SetType) &&
						(((SetType)element).getElementType().toString().equals
						 (elementType.toString()))){
						result = element;
						break;
					}
				}else if (type.equals("sequence")){
					if ((element instanceof SequenceType) &&
						(((SequenceType)element).getElementType().toString().
						 equals (elementType.toString()))){
						result = element;
						break;
					}
				}
			}
		}
		return (Type)result;
	}
	
	

}
