//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_AbstractExpressionTailList.java,v 1.2 2000/02/10 00:37:07 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_AbstractExpressionTailList.java,v $
//  Revision 1.2  2000/02/10 00:37:07  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.1  1999/10/27 20:43:26  cvs
//  The huge commit - shifting the sldl-lrm archive from uc to kansas. The
//  SldlParser.jj still has holes - but committing it anyway.
//
//  Revision 1.1  1999/10/20 21:49:04  rkamath
//  The HUGE commit (moving from my personal archive to the "kbse" archive)
//  before it moves to Kansas...
//  These files will have the log-info from my archive; they can be ignored.
//  Work on this can start afresh once all the files are in place
//  The src/SldlParser.jj.pre has "holes" - but committing it anyway
//
//  Revision 1.1  1999/07/14 23:23:21  rkamath
//  Added a generic semCheck function in SOM_AbstractExpression
//  All the other "expressionTail"s now inherit from SOM_AbstractExpressionTail
//  So also for the "expressionTailList"s
//  SOM_Operator now inherits from SOM_Function
//
//
//=============================================================================
package SOM;

/** This represents the <B>AbstractExpressionTailList</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_AbstractExpressionTailList
extends SOM_List {

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_AbstractExpressionTailList() {
		super();
	}

	/** The Second Constructor
	 * @param eTail The SOM_AbstractExpressionTail to be stored first
	 * @return Not applicable
	 */
	public SOM_AbstractExpressionTailList(SOM_AbstractExpressionTail eTail) {
		super(eTail);
	}

	/** To append a SOM_AbstractExpressionTail
	 * @param eTail The SOM_AbstractExpressionTail to be appended
	 * @return void
	 */
	public void addElement(SOM_AbstractExpressionTail eTail) {
		super.addElement(eTail);
	}
}
