//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_ArgumentList.java,v 1.3 2000/02/10 00:37:08 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_ArgumentList.java,v $
//  Revision 1.3  2000/02/10 00:37:08  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.2  1999/11/15 03:16:27  cvs
//  Many changes - especially with unfolding of overloading. Everything
//  compiles now. Some features are yet to be coded...but it is now again
//  a rudimentary parser (as it was two weeks ago :)
//
//  Revision 1.1  1999/10/27 20:43:27  cvs
//  The huge commit - shifting the sldl-lrm archive from uc to kansas. The
//  SldlParser.jj still has holes - but committing it anyway.
//
//  Revision 1.1  1999/10/20 21:49:11  rkamath
//  The HUGE commit (moving from my personal archive to the "kbse" archive)
//  before it moves to Kansas...
//  These files will have the log-info from my archive; they can be ignored.
//  Work on this can start afresh once all the files are in place
//  The src/SldlParser.jj.pre has "holes" - but committing it anyway
//
//  Revision 1.1  1999/08/01 17:00:13  rkamath
//  Added new files for overload resolution
//
//=============================================================================
package SOM;

import util.List;

/** This represents the <B>ArgumentList</B> object This name is a
 * misnomer - it is used in tandem with SOM_Tree for overloading
 * resolution and stores a list of arguments - each argument is
 * actually a single type (or multiple types that it can potentially
 * be) encased within a SOM_Tree
 * @see SOM.SOM_Tree
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_ArgumentList
extends List {

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_ArgumentList() {
		super();
	}

	/** The Second Constructor
	 * @param nodeListIn The first SOM_TreeNodeList object to be added
	 * @return Not applicable
	 */
	public SOM_ArgumentList(SOM_TreeNodeList nodeListIn) {
		super(nodeListIn);
	}

	/** To add a SOM_TreeNodeList to the argument list
	 * @param nodeListIn The SOM_TreeNodeList object to be added
	 * @return void
	 */
	public void addElement(SOM_TreeNodeList nodeListIn) {
		super.addElement(nodeListIn);
	}
}
