//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_AssociationItem.java,v 1.2 2000/02/10 00:37:09 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_AssociationItem.java,v $
//  Revision 1.2  2000/02/10 00:37:09  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.1  1999/10/27 20:43:28  cvs
//  The huge commit - shifting the sldl-lrm archive from uc to kansas. The
//  SldlParser.jj still has holes - but committing it anyway.
//
//  Revision 1.1  1999/10/20 21:49:17  rkamath
//  The HUGE commit (moving from my personal archive to the "kbse" archive)
//  before it moves to Kansas...
//  These files will have the log-info from my archive; they can be ignored.
//  Work on this can start afresh once all the files are in place
//  The src/SldlParser.jj.pre has "holes" - but committing it anyway
//
//  Revision 1.3  1999/07/22 22:53:15  rkamath
//  Lot of changes especially in terms of adding accessors to the OM
//  This does not compile completely, the toString() of SOM_FormalIdentifier
//  is to be completed. This commit is purely for records
//
//  Revision 1.2  1999/07/03 19:35:38  rkamath
//  Corrected the common-prefix of <factor> mainly..
//
//  Revision 1.1  1999/07/01 22:58:47  rkamath
//  Added these files pertaining to the <name> nonterminal. However I need to
//  fix the grammar using VHDL style of association.
//
//
//=============================================================================
package SOM;

/** This represents the <B>AssociationItem</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_AssociationItem
extends SOM_BaseClass{

	private SOM_Identifier identifier = null; // since it is optional
	private SOM_Expression expression;

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_AssociationItem() {
		super();
	}

	/** To set the identifier
	 * @param idIn The SOM_Identifier to be set
	 * @return void
	 */
	public void setIdentifier(SOM_Identifier idIn){
		identifier = idIn;
	}

	/** to get the identifier
	 * @return The SOM_Identifier stored here
	 */
	public SOM_Identifier getIdentifier() {
		return identifier;
	}

	/** To set the expression
	 * @param expressionIn The SOM_Expression to be set
	 * @return void
	 */
	public void setExpression(SOM_Expression expressionIn) {
		expression = expressionIn;
	}

	/** To get the expression
	 * @return The SOM_Expression stored here
	 */
	public SOM_Expression getExpression() {
		return expression;
	}
}
