//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_ComponentDeclarativeBlock.java,v 1.3 2000/02/17 01:20:13 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_ComponentDeclarativeBlock.java,v $
//  Revision 1.3  2000/02/17 01:20:13  cvs
//  Completed the implementation for component declarations (with the help of
//  makarand); this involved grammar changes, populating the object model and
//  also the pretty-printing.
//  - krishna
//
//  Revision 1.2  2000/02/10 00:37:11  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.1  1999/11/11 00:04:19  cvs
//  Fresh changes as part of the streamlining process with new
//  object model and grammar
//
//
//=============================================================================
package SOM;

import util.ListEnumeration;

import java.io.PrintWriter;

/** This represents the <B>ComponentDeclarativeBlock</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_ComponentDeclarativeBlock
extends SOM_BaseClass {

	private SOM_ComponentDeclarativeItemList itemList = new SOM_ComponentDeclarativeItemList();

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_ComponentDeclarativeBlock() {
		super();
	}

	/** To add a ComponentDeclarativeItem to the itemList
	 * @param itemIn The SOM_ComponentDeclarativeItem to be added to the itemList
	 * @return void
	 */
	public void addToComponentDeclarativeItemList(SOM_ComponentDeclarativeItem itemIn) {
		itemList.addElement(itemIn);
	}

	/** To retrieve the listEnumeration of the itemList
	 * @return The ListEnumeration corresponding to the itemList
	 */
	public ListEnumeration items() {
		return itemList.elements();
	}

	/** The publishSOM routine for this class
	 * @return void
	 */
	public void publishSOM(PrintWriter pw) {
		ListEnumeration itemEnum = this.items();
		SOM_ComponentDeclarativeItem item;

		while (itemEnum.hasMoreElements()) {
			item = (SOM_ComponentDeclarativeItem)itemEnum.nextElement();
			item.publishSOM(pw);
		}
	}

}

