//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_ComponentDeclarativeItem.java,v 1.5 2000/05/18 18:03:41 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_ComponentDeclarativeItem.java,v $
//  Revision 1.5  2000/05/18 18:03:41  cvs
//  Due to /projects directory failing and the latest version available is old, I
//  am committing the files again.
//  -- Cindy
//
//  Revision 1.5  2000/05/05 19:28:29  cvs
//  Added:
//  	- use of record and tuple keywords for record and tuple formers
//  	- new syntax for sel, forall, exists, min, max and ran functions
//  	- all expressions between "begin" and "end" are labelled.
//  Also, SOM_FacetBodyItem is no longer an interface, but a class.
//  - Cindy
//
//  Revision 1.4  2000/03/23 00:22:45  cvs
//  Huge commit! Added all the essential accessor methods for the following classes
//  - Krishna and Makarand
//
//  Revision 1.3  2000/02/17 01:20:14  cvs
//  Completed the implementation for component declarations (with the help of
//  makarand); this involved grammar changes, populating the object model and
//  also the pretty-printing.
//  - krishna
//
//  Revision 1.2  2000/02/10 00:37:11  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.1  1999/11/11 00:04:20  cvs
//  Fresh changes as part of the streamlining process with new
//  object model and grammar
//
//
//=============================================================================
package SOM;

import java.io.PrintWriter;
import java.io.Serializable;

/** This represents the <B>ComponentDeclarativeItem</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public interface SOM_ComponentDeclarativeItem
extends Serializable {

	/** The publishSOM routine for this class
	 * @return void
	 */
	public void publishSOM(PrintWriter pw);

}
