//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_DesignUnit.java,v 1.12 2000/12/05 03:05:02 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_DesignUnit.java,v $
//  Revision 1.12  2000/12/05 03:05:02  cvs
//  Modified semantic checking accordingly after grammar was changed to
//  have all files starting with package.
//  -- Cindy
//
//  Revision 1.11  2000/10/22 18:42:02  cvs
//  Meta functions are added to the SOM_InterfaceItem class and the
//  meta function M__Domain is changed so that it returns a string and
//  not SOM_FacetExpression 
//  --srinivas
//
//  Revision 1.10  2000/07/14 23:01:21  cvs
//  Made changes to the meta functions and added some meta functions
//  to the identifier object. 
//  --srinivas
//
//  Revision 1.9  2000/06/22 17:22:40  cvs
//  I modified the grammar to remove an error during parsing for
//  record and tuple. 
//  -- Cindy
//
//  Revision 1.8  2000/04/08 02:21:58  cvs
//  The Meta Functions have been implemented and these are the files
//  that had to be modified.Addded some accessor methods to classes
//  like SOM_DeclarationStatement, SOM_Expression,
//  SOM_RecordTupleDeclarationStatement.The Meta functions for facet
//  terms and the term items are implemented  
//  --srinivas
//
//  Revision 1.7  2000/03/23 00:22:46  cvs
//  Huge commit! Added all the essential accessor methods for the
//  following classes 
//  - Krishna and Makarand
//
//  Revision 1.6  2000/03/03 18:38:28  cvs
//  Seriliazing and deserializing the object model - makarand
//
//  Revision 1.5  2000/02/10 00:37:13  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.4  2000/02/08 18:42:21  cvs
//  Completed populating the object model and publishing the object model.
//  Added 'publishSOM(PrintWriter)' method to all necessary classes
//  (with the help 
//  of Makarand and Srini). Removed some unnecessary classes (due to changes
//  brought to the grammar). Renamed SOM_EqualityOperator to
//  SOM_EqualEqualOperator. Modified SldlParser.jj.h to populate the
//  object model. 
//  -- Cindy.
//
//  Revision 1.3  1999/11/16 04:05:23  cvs
//  Added support for export clause and visiblity
//
//  Revision 1.2  1999/11/13 20:01:26  cvs
//  Changed to the new OM and grammar. Some more features are to be added
//  and many bugs to be corrected. This is a commit for record and it compiles
//
//  Revision 1.1  1999/10/27 20:43:30  cvs
//  The huge commit - shifting the sldl-lrm archive from uc to kansas. The
//  SldlParser.jj still has holes - but committing it anyway.
//
//  Revision 1.1  1999/10/20 21:49:31  rkamath
//  The HUGE commit (moving from my personal archive to the "kbse" archive)
//  before it moves to Kansas...
//  These files will have the log-info from my archive; they can be ignored.
//  Work on this can start afresh once all the files are in place
//  The src/SldlParser.jj.pre has "holes" - but committing it anyway
//
//  Revision 1.4  1999/07/09 22:21:08  rkamath
//  A lot of changes to incorporate the intent of type checking
//
//  Revision 1.3  1999/06/25 15:10:20  rkamath
//  Modified the Makefile and changed the javadoc comments in the java files
//
//  Revision 1.2  1999/06/23 18:34:57  rkamath
//  A fresh new addition and modification of new files
//
//  Revision 1.1  1999/06/18 21:14:59  rkamath
//  The first commit for the SOM (SLDL Object Model). The DesignUnit
//  is purely to 
//  enable compilation and is yet incomplete...
//
//
//=============================================================================
package SOM;

import util.ListEnumeration;
import java.io.*;

/** This represents the <B>DesignUnit</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
// made serializable by makarand

public interface SOM_DesignUnit extends Serializable {

	/** To get the exports
	 * @return The ListEnumeration corresponding to the export clauses
	 */
	public ListEnumeration exports();

	/** added by krishna on Mar 5, 2000
	 * temp virtual function to access objects in SOM
	 * remember to rename this and other similar methods to getItems()
	 */
	public ListEnumeration M__Terms();
	public ListEnumeration M__Params();
	public String M__Domain();
	public ListEnumeration M__Pvars();
	public ListEnumeration M__Items();
	public ListEnumeration M__Types();
	public ListEnumeration M__Visible();

    // All design Units have a publishSOM method
    /** The publishSOM routine for this class
     * @return void
     */
    public void publishSOM(PrintWriter pw);
}
