//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//           Cindy ckong@ittc.ukans.edu
//
//  $Id: SOM_DollarOperator.java,v 1.2 2000/08/01 22:48:46 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_DollarOperator.java,v $
//  Revision 1.2  2000/08/01 22:48:46  cvs
//  added publishPVS templates in each of the expression subclasses.
//  Currently SOCCER supports PVS translation of "%" and "-" unary operator,
//  other translations can be done in these publishPVS templates as and when
//  needed - makarand.
//
//  Revision 1.1  2000/04/28 19:34:06  cvs
//  Added some more of typechecking. Added parsing of the $ operator and constant literal.
//  -- Cindy
//
//
//=============================================================================
package SOM;

import java.io.PrintWriter;

/** This represents the <B>DollarOperator</B> object
 * @author <I>Roshan Kamath and Cindy Kong</I> (rkamath@ececs.uc.edu, ckong@ittc.ukans.edu)
 */
public class SOM_DollarOperator
extends SOM_MonoadicOperator {

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_DollarOperator() {
		super();
	}

	/** The publishRosetta routine for this terminal
	 * @return void
	 */
	public void publishRosettaTerminal(PrintWriter pw) {
		pw.print(" $ ");
	}

	/** To get the string representation of this object
	 * @return String representation of this operator
	 */
	public String toString() {
			return new String("$");
	}

    /** publishSOM routine needed to print the object module
     * @return void
     */
    public void publishSOM(PrintWriter pw){
				pw.print(" $");
    }

		/** The publishPVS routine for this class
		 * @return void
     * To be implemented as needed */
		public void publishPVS(PrintWriter pw) {
        publishSOM(pw);
		} 
}
