
package SOM;

import util.ListEnumeration;
import java.io.PrintWriter;

/** This represents the <B>DomainBody</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 * @see SOM.SOM_BaseClass
 */
public class SOM_DomainBody
extends SOM_BaseClass {

	private SOM_DomainBodyItemList itemList = new SOM_DomainBodyItemList();

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_DomainBody() {
		super();
	}

	/** To add a DomainBodyItem to the itemList
	 * @param itemIn The SOM_DomainBodyItem to be added to the itemList
	 * @return void
	 */
	public void addToDomainBodyItemList(SOM_DomainBodyItem itemIn) {
		itemList.addElement(itemIn);
	}

	/** To retrieve the listEnumeration of the itemList
	 * @return The ListEnumeration corresponding to the itemList
	 */
	public ListEnumeration items() {
		return itemList.elements();
	}

	/** The publishSOM routine for this class
	 * @return void
	 */
	public void publishSOM(PrintWriter pw) {
		ListEnumeration itemEnum = this.items();
		SOM_DomainBodyItem item;

		while (itemEnum.hasMoreElements()) {
			item = (SOM_DomainBodyItem)itemEnum.nextElement();
			item.publishSOM(pw);
			pw.print(";\n");
		}

	}
}

