
package SOM;

import util.ListEnumeration;

import java.io.PrintWriter;

/** This represents the <B>DomainDeclarativeBlock</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_DomainDeclarativeBlock
extends SOM_BaseClass {

	private SOM_DomainDeclarativeItemList itemList = new SOM_DomainDeclarativeItemList();

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_DomainDeclarativeBlock() {
		super();
	}

	/** To add a DomainDeclarativeItem to the itemList
	 * @param itemIn The SOM_DomainDeclarativeItem to be added to the itemList
	 * @return void
	 */
	public void addToDomainDeclarativeItemList(SOM_DomainDeclarativeItem itemIn) {
		itemList.addElement(itemIn);
	}

	/** To retrieve the listEnumeration of the itemList
	 * @return The ListEnumeration corresponding to the itemList
	 */
	public ListEnumeration items() {
		return itemList.elements();
	}

	/** The publishSOM routine for this class
	 * @return void
	 */
	public void publishSOM(PrintWriter pw) {
		ListEnumeration itemEnum = this.items();
		SOM_DomainDeclarativeItem item;

		while (itemEnum.hasMoreElements()) {
			item = (SOM_DomainDeclarativeItem)itemEnum.nextElement();
			item.publishSOM(pw);
		}
	}
}

