
package SOM;

import java.io.PrintWriter;
import java.io.Serializable;

/** This represents the <B>DomainDefinition</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */

// made serializable by makarand

public class SOM_DomainDefinition
extends SOM_BaseClass 
implements Serializable {

	/** Local data members */
	SOM_DomainDeclarativeBlock declBlock = null; //optional
	SOM_ExportBlock exportBlock = null; //optional
	SOM_FacetExpression domainExpression = null; // since it may be
	// the null keyword 
	SOM_DomainBody domainBody = null; // optional

	/* This list will store the declarations of this domain's parents as
		 given by the domainexpression */
	SOM_DeclarationList parentDeclList = null;

	/** The primary constructor
	 * @return Not applicable
	 */
	public SOM_DomainDefinition() {
		super();
	}

	/** To set the declBlock
	 * @param declBlockIn The SOM_DomainDeclarativeBlock to be set
	 * @return void
	 */
	public void setDomainDeclarativeBlock(SOM_DomainDeclarativeBlock 
										 declBlockIn) {
		declBlock = declBlockIn;
	}

	/** To get the declBlock
	 * @return The SOM_DomainDeclarativeBlock of this domain definition
	 */
	public SOM_DomainDeclarativeBlock getDomainDeclarativeBlock() {
		return declBlock;
	}


	/** To set the exportBlock
	 * @param exportBlockIn The SOM_ExportBlock to be set
	 * @return void
	 */
	public void setExportBlock(SOM_ExportBlock exportBlockIn) {
		exportBlock = exportBlockIn;
	}

	/** To get the exportBlock
	 * @return The SOM_ExportBlock of this domain definition
	 */
	public SOM_ExportBlock getExportBlock() {
		return exportBlock;
	}
		
	/** To set the domainExpression. Note assumes that the domain expression
	 * has been typechecked and resolved to type domain
	 * @param expressionIn The SOM_Expression object to be set
	 * @return void
	 */
	public void setDomainExpression(SOM_FacetExpression expressionIn) {
		domainExpression = expressionIn;
		// notice the fresh creation of the parentDeclList!
		// The alternative is to concat it to any already existing
		// parentDeclList 
		// the implementation will depend on the semantics of facet expressions
		// Commented out by Cindy Feb 22, 2000
		//parentDeclList = domainExpression.getNames();
	}
	
	/** added by srinivas to get the domain expression
	 *@param void
	 * @ return SOM_DomainExpression
	 */
    public SOM_FacetExpression getDomainExpression(){
		return domainExpression;
    }


	/** To get the parentDeclList
	 * @return SOM_DeclarationList that is the parentDeclList
	 */
	public SOM_DeclarationList getParentDeclarationList() {
		return parentDeclList;
	}

	/** To set the domainBody
	 * @param bodyIn The SOM_DomainBody to be set
	 * @return void
	 */
	public void setDomainBody(SOM_DomainBody bodyIn) {
		domainBody = bodyIn;
	}

	/** To get the domainBody
	 * @return The SOM_DomainBody of this domain definition
	 */
	public SOM_DomainBody getDomainBody() {
		return domainBody;
	}
  
   	/** The publishSOM routine for this class
	 * @return void
	 */
	public void publishSOM(PrintWriter pw) {
		if (declBlock != null) {
			declBlock.publishSOM(pw);
		}
		if (exportBlock != null) {
			exportBlock.publishSOM(pw);
		}
		pw.print("begin ");
		if (domainExpression != null) {
			domainExpression.publishSOM(pw);
			pw.println();
		} else {
			pw.println("null ");
		}
		if (domainBody != null) {
			domainBody.publishSOM(pw);
		}
		pw.print("end ");
	}

}
