//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_DoubleQuote.java,v 1.2 2000/02/10 00:37:13 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_DoubleQuote.java,v $
//  Revision 1.2  2000/02/10 00:37:13  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.1  1999/11/07 18:21:58  cvs
//  Commit as part of streamlining the ObjectModel and bringing it in line
//  with the new Grammar
//
//
//=============================================================================
package SOM;

import java.io.PrintWriter;

/** This represents the <B>DoubleQuote</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_DoubleQuote
extends SOM_SpecialSymbols {

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_DoubleQuote() {
		super();
	}

	/** The publishRosetta routine for this terminal
	 * @return void
	 */
	public void publishRosettaTerminal(PrintWriter pw) {
		pw.print('"');
	}
}
