package SOM;

import util.ListEnumeration;

/** This represents the <B>EnumerationItemDeclaration</B> object
 * @author <I>Brandon Morel</I> (morel@ittc.ku.edu)
 */
public class SOM_EnumerationItemDeclaration
    extends SOM_Declaration {

    protected SOM_Identifier EnumerationItemName;

    /** The primary constructor
     * @param EnumerationItemNameIn The SOM_Identifier for the name of the declaration
     * @param myType The SOM_TypeDeclaration corresponding to the
     * EnumerationItemMetaType
     * @return Not applicable
     */
    public SOM_EnumerationItemDeclaration(SOM_Identifier EnumerationItemNameIn,
					  SOM_TypeDeclaration myType) {
	super();
	setKind(SOM_Declaration.ENUMERATIONITEM);
	EnumerationItemName = EnumerationItemNameIn;
	setType(myType);
    }

    /** To get the string representation of this object. Overrides the
     * method in SOM_Declaration
     * @return String representation of this object
     */
    public String toString() {
	return EnumerationItemName.toString();
    }

    /** To implement my own version of isDistinguishable for types
     * @param declOne The first SOM_EnumerationItemDeclaration
     * @param declTwo The next SOM_EnumerationItemDeclaration to be distinguished
     * against declOne
     * @return true if they are distinguishable, false otherwise
     */
  /*
    public static boolean isDistinguishable
	(SOM_EnumerationItemDeclaration declOne, 
	 SOM_EnumerationItemDeclaration declTwo) { 
	SOM_DeclarationList fieldListOne = declOne.getFieldList();
	SOM_DeclarationList fieldListTwo = declTwo.getFieldList();
	
	SOM_EnumerationItemType typeOne = (SOM_EnumerationItemType)declOne.getType();
	SOM_EnumerationItemType typeTwo = (SOM_EnumerationItemType)declTwo.getType();
	if (!declOne.toString().equalsIgnoreCase(declTwo.toString()))
	    return true;
	else
	    return(SOM_EnumerationItemType.isDistinguishable(typeOne, typeTwo));
    }

  */
    /** To ascertain "compatiblity" for bindings of the kind lhs <- rhs
     * => RHS must be a subtype of LHS
     * @param declLHS The EnumerationItemDecl corresponding to the lhs object
     * @param declRHS The EnumerationItemDecl corresponding to the rhs object
     * @return true, if the rhs is assignable to the lhs, false otherwise
     */
  /*
    public static boolean
	isLeftCompatibleWithRight(SOM_EnumerationItemDeclaration declLHS,
				  SOM_EnumerationItemDeclaration declRHS) { 
	SOM_EnumerationItemType typeLHS = (SOM_EnumerationItemType)declLHS.getType();
	SOM_EnumerationItemType typeRHS = (SOM_EnumerationItemType)declRHS.getType();

	return SOM_EnumerationItemType.isLeftTypeCompatibleWithRightType(typeLHS, typeRHS);
    }
  */
}

