//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_EnumerationItemList.java,v 1.2 2000/02/10 00:37:14 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_EnumerationItemList.java,v $
//  Revision 1.2  2000/02/10 00:37:14  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.1  1999/10/27 20:43:32  cvs
//  The huge commit - shifting the sldl-lrm archive from uc to kansas. The
//  SldlParser.jj still has holes - but committing it anyway.
//
//  Revision 1.1  1999/10/20 21:49:43  rkamath
//  The HUGE commit (moving from my personal archive to the "kbse" archive)
//  before it moves to Kansas...
//  These files will have the log-info from my archive; they can be ignored.
//  Work on this can start afresh once all the files are in place
//  The src/SldlParser.jj.pre has "holes" - but committing it anyway
//
//  Revision 1.1  1999/07/06 21:01:34  rkamath
//  Having added the type expression syntax the corresponding OM...etc
//  Also now, only subclasses of RuntimeException are being thrown
//
//
//=============================================================================
package SOM;

/** This represents the <B>EnumerationItemList</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_EnumerationItemList
extends SOM_List {

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_EnumerationItemList() {
		super();
	}

	/** The Second Constructor
	 * @param enumItem The first SOM_EnumerationItem object to be added
	 * @return Not applicable
	 */
	public SOM_EnumerationItemList(SOM_EnumerationItem enumItem) {
		super((SOM_BaseClass)enumItem);
	}

	/** To add a SOM_EnumerationItem to the list
	 * @param enumItem The SOM_EnumerationItem object to be added
	 * @return void
	 */
	public void addElement(SOM_EnumerationItem enumItem) {
		super.addElement((SOM_BaseClass)enumItem);
	}
}
