//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//           Cindy ckong@ittc.ukans.edu
//
//  $Id: SOM_ExpTermTail.java,v 1.8 2000/08/01 22:48:47 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_ExpTermTail.java,v $
//  Revision 1.8  2000/08/01 22:48:47  cvs
//  added publishPVS templates in each of the expression subclasses.
//  Currently SOCCER supports PVS translation of "%" and "-" unary operator,
//  other translations can be done in these publishPVS templates as and when
//  needed - makarand.
//
//  Revision 1.7  2000/03/23 00:22:46  cvs
//  Huge commit! Added all the essential accessor methods for the following classes
//  - Krishna and Makarand
//
//  Revision 1.6  2000/03/22 03:21:27  cvs
//  Modified the grammar to remove thew production exptermtail and the classes are also modified
//  --srinivas
//
//  Revision 1.3  2000/02/10 00:37:15  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.2  2000/02/08 18:42:23  cvs
//  Completed populating the object model and publishing the object model.
//  Added 'publishSOM(PrintWriter)' method to all necessary classes (with the help
//  of Makarand and Srini). Removed some unnecessary classes (due to changes
//  brought to the grammar). Renamed SOM_EqualityOperator to
//  SOM_EqualEqualOperator. Modified SldlParser.jj.h to populate the object model.
//  -- Cindy.
//
//  Revision 1.1  2000/02/02 20:48:18  cvs
//  Committing SOM_ExpTermTail and SOM_TermTail.
//  -- Cindy
//
//
//=============================================================================
package SOM;

import java.io.PrintWriter;

/** This represents the <B>RelationalTermExpressionTail</B> object
 * @author <I>Roshan Kamath and Cindy Kong</I> (rkamath@ececs.uc.edu, ckong@ittc.ukans.edu)
 */

public class SOM_ExpTermTail
extends SOM_AbstractExpressionTail {

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_ExpTermTail() {
		super();
	}

	/** The second constructor
	 * @param opIn The SOM_DyadicOperator to be set
	 * @param exprIn The SOM_ExpTerm to be set
	 * @return Not applicable
	 *
	 */
	public SOM_ExpTermTail(SOM_DyadicOperator opIn, SOM_ExpTerm exprIn) {
		super();
		super.setOperator(opIn);
		super.setExpression(exprIn);
	}

	/** To set the operator
	 * @param opIn The SOM_DyadicOperator to be set
	 * @return void
	 
	public void setOperator(SOM_DyadicOperator opIn) {
		super.setOperator(opIn);
	}
	*/

	/** To set the ExpTerm
	 * @param exprIn The SOM_ExpTerm to be set
	 * @return void
	 *
	 */
	public void setSimpleExpression(SOM_ExpTerm exprIn) {
			setExpression(exprIn);
	}

  /** To get the ExpTerm
	 * @return  The SOM_ExpTerm
	 */
	public SOM_ExpTerm getExpTerm() {
		return (SOM_ExpTerm)getExpression();
	}

	/** The publishSOM routine for this class
	 * @return void
	 */
	public void publishSOM(PrintWriter pw) {
		getExpression().publishSOM(pw);
	}


	/** The publishPVS routine for this class
	 * @return void
	 */
	public void publishPVS(PrintWriter pw) {
			publishSOM(pw);
	}
}



