//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_FacetBodyItem.java,v 1.7 2000/05/18 18:03:43 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_FacetBodyItem.java,v $
//  Revision 1.7  2000/05/18 18:03:43  cvs
//  Due to /projects directory failing and the latest version available is old, I
//  am committing the files again.
//  -- Cindy
//
//  Revision 1.7  2000/05/05 19:28:31  cvs
//  Added:
//  	- use of record and tuple keywords for record and tuple formers
//  	- new syntax for sel, forall, exists, min, max and ran functions
//  	- all expressions between "begin" and "end" are labelled.
//  Also, SOM_FacetBodyItem is no longer an interface, but a class.
//  - Cindy
//
//  Revision 1.6  2000/04/11 03:17:52  cvs
//  The dummy M__Label and M__Value functions have been removed .
//  --srinivas
//
//  Revision 1.5  2000/03/23 00:22:46  cvs
//  Huge commit! Added all the essential accessor methods for the following classes
//  - Krishna and Makarand
//
//  Revision 1.4  2000/03/03 18:38:28  cvs
//  Seriliazing and deserializing the object model - makarand
//
//  Revision 1.3  2000/02/10 00:37:17  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.2  2000/02/08 18:42:26  cvs
//  Completed populating the object model and publishing the object model.
//  Added 'publishSOM(PrintWriter)' method to all necessary classes (with the help
//  of Makarand and Srini). Removed some unnecessary classes (due to changes
//  brought to the grammar). Renamed SOM_EqualityOperator to
//  SOM_EqualEqualOperator. Modified SldlParser.jj.h to populate the object model.
//  -- Cindy.
//
//  Revision 1.1  1999/11/05 23:43:07  cvs
//  Modified this file as part of streamlining the ObjectModel and bringing
//  it in line with the new grammar
//
//
//=============================================================================
package SOM;

import java.io.PrintWriter;
import java.io.*;
import util.*;

/** This represents the <B>FacetBodyItem</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */

// made Serializable by makarand 
public class SOM_FacetBodyItem 
extends SOM_BaseClass {

	private SOM_LabelledExpression labelledExpr;

	/** Constructor
	 * @return Not applicable
	 */
	public SOM_FacetBodyItem() {
		super();
	}
	
	/** To set the labelled expression
	 * @param labelExprIn The SOM_LabelledExpression to be set
	 * @return void
	 */
	public void setLabelledExpression(SOM_LabelledExpression labelExprIn) {
		labelledExpr = labelExprIn;
	}

	/** To get the labelled expression
	 * @return The SOM_LabelledExpression 
	 */
	public SOM_LabelledExpression getLabelledExpression() {
		return labelledExpr;
	}
		
	/** The publishSOM routine for this class
	 * @return void
	 */
	public void publishSOM(PrintWriter pw) {
		labelledExpr.publishSOM(pw);
	}

}









