//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: srinivas akki@ittc.ukans.edu
//
//  $Id: SOM_FacetDeclarationStatement.java,v 1.6 2001/10/01 18:46:09 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_FacetDeclarationStatement.java,v $
//  Revision 1.6  2001/10/01 18:46:09  cvs
//  When parsing, type info is only printed out when printInfo flag in
//  Sldl.java is set to true. Other changes include tabulation set to 2.
//  -- Cindy
//
//  Revision 1.5  2000/12/05 03:05:03  cvs
//  Modified semantic checking accordingly after grammar was changed to
//  have all files starting with package.
//  -- Cindy
//
//  Revision 1.4  2000/07/11 00:11:10  cvs
//  Change in the grammar: type, set, bunch, array, record, tuple and
//  sequence are 
//  keywords. Typechecking for set is done. Added SetType and FunctionType.
//  False and true are predefined as boolean.
//  -- Cindy
//
//  Revision 1.3  2000/03/07 23:01:02  cvs
//  Modified the class due the change in syntax of function , facet
//  dedclarations and the unnamed functions 
//  --srinivas
//
//  Revision 1.2  2000/02/29 21:11:22  cvs
//  manually added the log messages corresponding to the previous commit
//  -- srinivas
//
//  Revision 1.1  2000/02/29 18:06:23  cvs
//  added this new production facet declaration statement . made the
//  necessary //changes to the grammar also 
// -- srinivas
//
//============================================================================
package SOM;


import util.ListEnumeration;

import java.io.PrintWriter;

public class SOM_FacetDeclarationStatement 
extends SOM_BaseClass {

  private SOM_FacetExpression facetExpr= null;
	  
	/** The primary Constructor
	 * @return Not applicable
	 */
  public SOM_FacetDeclarationStatement() {
    super();
  }

  /** To set the facetExpression. Note assumes that the domain ex 
	 * @param expressionIn The SOM_Expression object to be set
	 * @return void
	 */
  public void setFacetExpression(SOM_FacetExpression expressionIn) {
    facetExpr = expressionIn;
  }
 
  /** To set the facetExpression. Note assumes that the domain ex 
	 * @return SOM_FacetExpression, the facet expression
	 */
  public SOM_FacetExpression getFacetExpression() {
    return facetExpr;
  }

  public void publishSOM(PrintWriter pw){
    pw.print(" FACET ");
    if (facetExpr != null){
      pw.print(" IS");
      facetExpr.publishSOM(pw);
    }
  }
}
