//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_Identifier.java,v 1.22 2001/03/12 23:54:38 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_Identifier.java,v $
//  Revision 1.22  2001/03/12 23:54:38  cvs
//  Changed the order of precedence of the "=" operator. It now has lowest
//  precedence of all operators except for the "==" operator. Added some
//  type checking for facet expressions and as a result, domain names have
//  to be legal facet names. Removed several bugs as well.
//  -- Cindy
//
//  Revision 1.21  2000/11/18 00:18:27  cvs
//  Changed the M__Value method so that it takes ROM.Factory as a parameter
//  --srinivas
//
//  Revision 1.20  2000/11/13 23:36:39  cvs
//  Changed the way the Items are created.Now they are created through
//  the factory class 
//  --srinivas
//
//  Revision 1.19  2000/10/30 22:13:23  cvs
//  The M__Value  function is implemented for the
//  terms(SOM_LabelledExpression) and it returns a ROM Expression. 
//  --srinivas
//
//  Revision 1.18  2000/09/15 04:29:12  cvs
//  Changed the publishSOM method by removing the space before the
//  identifier.The previous commits didnot go through due to CVS
//  problems 
//  --krishna
//
//  Revision 1.17  2000/08/30 20:10:40  cvs
//  Changed the publishSOM function in the class SOM_Identifier by
//  removing an extra space 
//  --srinivas
//
//  Revision 1.16  2000/08/10 00:38:29  cvs
//  added publishPVS routine in Formal name class and modified the
//  exisiting publishPVS routines in AttickExpression and Identifier
//  to remove an error during conversion of tick to underscore - makarand
//
//  Revision 1.15  2000/08/01 22:48:49  cvs
//  added publishPVS templates in each of the expression subclasses.
//  Currently SOCCER supports PVS translation of "%" and "-" unary operator,
//  other translations can be done in these publishPVS templates as and when
//  needed - makarand.
//
//  Revision 1.14  2000/07/24 23:41:02  cvs
//  Some type checking added for record and sequence.
//  -- Cindy
//
//  Revision 1.13  2000/07/14 23:01:22  cvs
//  Made changes to the meta functions and added some meta functions
//  to the identifier object. 
//  --srinivas
//
//  Revision 1.12  2000/07/11 00:11:12  cvs
//  Change in the grammar: type, set, bunch, array, record, tuple and
//  sequence are 
//  keywords. Typechecking for set is done. Added SetType and FunctionType.
//  False and true are predefined as boolean.
//  -- Cindy
//
//  Revision 1.11  2000/06/22 17:22:43  cvs
//  I modified the grammar to remove an error during parsing for
//  record and tuple. 
//  -- Cindy
//
//  Revision 1.10  2000/04/09 01:50:03  cvs
//   The identifier had a space printed in the publishSOM which was
//   not required for the tick and the at operators so changing the
//   classes and the grammar had the tick and single quote
//   interchanged so modifing the grammar also 
//  --srinivas
//
//  Revision 1.9  2000/04/06 19:13:21  cvs
//  Type checking is done for declaration of variables (simple types),
//  for declaration of new types and for use of basic operators. 
//   -- Cindy
//
//  Revision 1.8  2000/03/23 00:22:47  cvs
//  Huge commit! Added all the essential accessor methods for the
//  following classes 
//  - Krishna and Makarand
//
//  Revision 1.7  2000/03/03 18:38:29  cvs
//  Seriliazing and deserializing the object model - makarand
//
//  Revision 1.6  2000/02/10 00:37:20  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.5  2000/02/08 18:42:29  cvs
//  Completed populating the object model and publishing the object model.
//  Added 'publishSOM(PrintWriter)' method to all necessary classes
//  (with the help of Makarand and Srini). Removed some unnecessary
//  classes (due to changes brought to the grammar). Renamed
//  SOM_EqualityOperator to SOM_EqualEqualOperator. Modified
//  SldlParser.jj.h to populate the object model. 
//  -- Cindy.
//
//  Revision 1.4  1999/11/17 18:31:54  cvs
//  Coded resolution of final type (unfolding overload resolution) and included
//  actions for TCC generation
//
//  Revision 1.3  1999/11/13 20:01:27  cvs
//  Changed to the new OM and grammar. Some more features are to be added
//  and many bugs to be corrected. This is a commit for record and it compiles
//
//  Revision 1.2  1999/11/11 00:04:23  cvs
//  Fresh changes as part of the streamlining process with new
//  object model and grammar
//
//  Revision 1.1  1999/10/27 20:43:37  cvs
//  The huge commit - shifting the sldl-lrm archive from uc to kansas. The
//  SldlParser.jj still has holes - but committing it anyway.
//
//  Revision 1.1  1999/10/20 21:50:17  rkamath
//  The HUGE commit (moving from my personal archive to the "kbse" archive)
//  before it moves to Kansas...
//  These files will have the log-info from my archive; they can be ignored.
//  Work on this can start afresh once all the files are in place
//  The src/SldlParser.jj.pre has "holes" - but committing it anyway
//
//  Revision 1.8  1999/07/28 01:59:40  rkamath
//  Changed all the SOM_Declaration references to SYM_SymboltableEntry as far
//  as lookUp and typeResolution are concerned
//
//  Revision 1.7  1999/07/22 22:53:20  rkamath
//  Lot of changes especially in terms of adding accessors to the OM
//  This does not compile completely, the toString() of SOM_FormalIdentifier
//  is to be completed. This commit is purely for records
//
//  Revision 1.6  1999/07/13 14:27:20  rkamath
//  Changed the publishRosetta() function to take in a PrintWriter
//  Added some new classes too.
//  Also commented out currency based operations from the SOM_List class. Hope-
//  fully at a later date I'll include them in the SOM_ListEnumeration class if
//  found necessary.
//
//  Revision 1.5  1999/07/10 21:31:23  rkamath
//  The commit for today. Introduced a toString() function in
//  SOM_Declaration that 
//  will be used to hash "declarations" into the symboltable
//
//  Revision 1.4  1999/06/30 22:19:58  rkamath
//  Compeleted the object model coding for the expression grammar
//  The expression objects now inherit from a AbstractExpression class
//
//  Revision 1.3  1999/06/27 17:33:31  rkamath
//  Added some of the object model for the Expression grammar and a
//  few changes to 
//  the other files..
//
//  Revision 1.2  1999/06/25 15:10:30  rkamath
//  Modified the Makefile and changed the javadoc comments in the java files
//
//  Revision 1.1  1999/06/23 18:35:08  rkamath
//  A fresh new addition and modification of new files
//
//
//=============================================================================
package SOM;

import SYM.SYM_UnresolvableException;

import util.ListEnumeration;
import ROM.*;
import java.io.PrintWriter;
import java.io.*;


/** This represents the <B>Identifier</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */

// made serializable by makarand
public class SOM_Identifier
extends SOM_Name
implements SOM_Terminal, Serializable {

	private String identifier;

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_Identifier() {
		super();
	}

	/** The second constructor
	 * @param identifierIn The String corresponding to this identifier object
	 * @return Not applicable
	 */
	public SOM_Identifier(String identifierIn) {
		identifier = identifierIn;
	}

	/** To set the string corresponding to the identifier
	 * @param identifierIn The String corresponding to this identifier object
	 * @return void
	 */
	public void setIdentifier(String identifierIn) {
		identifier = identifierIn;
	}

	/** To get the string corresponding to the identifier
	 * @return The String corresponding to this identifier object
	 */
	public String getIdentifier() {
		return identifier;
	}

	/** Overriding the getName from SOM_Name
	 * @return null
	 */
	public SOM_Name getName() {
		return null;
	}

	/** Overrides the resolveFinalType from SOM_AbstractExpression. This is
	 * called by the external world. 
	 * @return void
	 */
	public void resolveFinalType() {
		// The set should have resulted in a single type.
		SOM_TreeNodeList typeList = getTypeList();
		if (typeList.countElements() != 1)
			throw  new SYM_UnresolvableException
				("Cannot resolve final type for expression in Identifier");
		
		// else the final type is the sole element of the typeList.
		SOM_TreeNode onlyNode = (SOM_TreeNode)typeList.first();
		setResolvedType(onlyNode.getResultType());
		
	}

	/** overrides the resolveFinalType from SOM_AbstractExpression.
	 * @param typeIn The SOM_TypeExpression which is the expected final type
	 * @return void
	 */
	public void resolveFinalType(SOM_TypeDeclaration typeIn) {
		// typeIn should be one of the types in typeList

		ListEnumeration typeEnum = getTypeList().elements();
		SOM_TreeNode currNode;
		SOM_TypeDeclaration currType;

		//System.out.println("Fresh TCC Generation");

		while (typeEnum.hasMoreElements()) {
			//System.out.println("New Cycle");

			try {
				currNode = (SOM_TreeNode)typeEnum.nextElement();
				currType = currNode.getResultType();
				
				if (SOM_TypeDeclaration.resolveFinalType(currType, typeIn)) {
					setResolvedType(currType);
					//System.out.println("End Fresh TCC Generation");
					return;
				}
			} catch (SYM_UnresolvableException except) {
				// means that some assocation failed to resolve
				// go to the next currType in typeEnum
				//System.out.println("Flush previous cycle");
				//System.out.println("New Cycle");
			}
		}

		//System.out.println("End Fresh TCC Generation");
		
		// typeIn was not found in the overload resovled types.
		throw  new SYM_UnresolvableException
			("Cannot resolve final type for expression in Identifier");
	}

	/** To get the string representation of this object
	 * @return String representation of this SOM_Identifier
	 */
	public String toString() {
		return new String(identifier);		
	}
   /** Added by srinivas on june 26 2000
     * To get the type of a identifier
     * in the facet
     */  
    public String M__Type(){
	//	resolveFinalType();
	return getResolvedType().toString();
    }
    /** Added by srinivas on june 26th 2000
     * To get the label,String of a identifier
     * in the facet
     */  
    public String M__Label(){
        return identifier;
    }
    /** Added by srinivas on june 26 2000
     * To get the String of a identifier
     * in the facet
     */  
    public String M__String(){
        return identifier;
    }

	//added by srinivas on Oct 24th 2000
    /*The Meta Function to get the value of the item
     *@param BaseObject parent
	 *@param Universe root
     * @return Expression
     */	
    public Expression M__Value(Factory romFactory, BaseObject parent, 
							   Universe root){
        Label label = new Label(identifier);
		Item item = parent.labelLookup(label);
		ItemReference itemRef = new ItemReference(parent, item);
		return (Expression)itemRef;
    }    
    
	/** The publishRosetta routine for this terminal
	 * @return void
	 */
	public void publishRosettaTerminal(PrintWriter pw) {
		pw.print(identifier);
	}
    
    public void publishSOM(PrintWriter pw){
		pw.print(identifier);
	}

	/** added by makarand */
	public void publishPVS(PrintWriter pw){
		pw.print(identifier);
	}
}




