
package SOM;

import util.ListEnumeration;
import java.io.PrintWriter;

/** This represents the <B>InteractionBody</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 * @see SOM.SOM_BaseClass
 */
public class SOM_InteractionBody
extends SOM_BaseClass {

	private SOM_InteractionBodyItemList itemList = new SOM_InteractionBodyItemList();

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_InteractionBody() {
		super();
	}

	/** To add a InteractionBodyItem to the itemList
	 * @param itemIn The SOM_InteractionBodyItem to be added to the itemList
	 * @return void
	 */
	public void addToInteractionBodyItemList(SOM_InteractionBodyItem itemIn) {
		itemList.addElement(itemIn);
	}

	/** To retrieve the listEnumeration of the itemList
	 * @return The ListEnumeration corresponding to the itemList
	 */
	public ListEnumeration items() {
		return itemList.elements();
	}

	/** The publishSOM routine for this class
	 * @return void
	 */
	public void publishSOM(PrintWriter pw) {
		ListEnumeration itemEnum = this.items();
		SOM_InteractionBodyItem item;

		while (itemEnum.hasMoreElements()) {
			item = (SOM_InteractionBodyItem)itemEnum.nextElement();
			item.publishSOM(pw);
			pw.print(";\n");
		}

	}
}

