
package SOM;

import util.ListEnumeration;

import java.io.PrintWriter;

/** This represents the <B>InteractionDeclarativeBlock</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_InteractionDeclarativeBlock
extends SOM_BaseClass {

	private SOM_InteractionDeclarativeItemList itemList = new SOM_InteractionDeclarativeItemList();

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_InteractionDeclarativeBlock() {
		super();
	}

	/** To add a InteractionDeclarativeItem to the itemList
	 * @param itemIn The SOM_InteractionDeclarativeItem to be added to the itemList
	 * @return void
	 */
	public void addToInteractionDeclarativeItemList(SOM_InteractionDeclarativeItem itemIn) {
		itemList.addElement(itemIn);
	}

	/** To retrieve the listEnumeration of the itemList
	 * @return The ListEnumeration corresponding to the itemList
	 */
	public ListEnumeration items() {
		return itemList.elements();
	}

	/** The publishSOM routine for this class
	 * @return void
	 */
	public void publishSOM(PrintWriter pw) {
		ListEnumeration itemEnum = this.items();
		SOM_InteractionDeclarativeItem item;

		while (itemEnum.hasMoreElements()) {
			item = (SOM_InteractionDeclarativeItem)itemEnum.nextElement();
			item.publishSOM(pw);
		}
	}
}

