
package SOM;

import java.io.PrintWriter;
import java.io.Serializable;
import java.lang.String;
/** This represents the <B>InteractionDefinition</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */

// made serializable by makarand

public class SOM_InteractionDefinition
extends SOM_BaseClass 
implements Serializable {

    /** Local data members */
    SOM_InteractionDeclarativeBlock declBlock = null; //optional
    SOM_ExportBlock exportBlock = null; //optional
    SOM_FacetExpression domainExpression = null; // since it may be
    // the null keyword 
    SOM_InteractionBody interactionBody = null; // optional
    
    /* This list will store the declarations of this interaction parents as
       given by the domain expression */
    SOM_DeclarationList parentDeclList = null;
    
    /** The primary constructor
     * @return Not applicable
     */
    public SOM_InteractionDefinition() {
	super();
    }
    
    /** To set the declBlock
     * @param declBlockIn The SOM_INteractionDeclarativeBlock to be set
     * @return void
     */
	public void setInteractionDeclarativeBlock(SOM_InteractionDeclarativeBlock 
						   declBlockIn) {
	    declBlock = declBlockIn;
	}
    
    /** To get the declBlock
     * @return The SOM_InteractionDeclarativeBlock of this Interaction definition
     */
    public SOM_InteractionDeclarativeBlock getInteractionDeclarativeBlock() {
		return declBlock;
    }
    
    
    /** To set the exportBlock
     * @param exportBlockIn The SOM_ExportBlock to be set
     * @return void
     */
    public void setExportBlock(SOM_ExportBlock exportBlockIn) {
	exportBlock = exportBlockIn;
    }
    
    /** To get the exportBlock
     * @return The SOM_ExportBlock of this interaction definition
     */
    public SOM_ExportBlock getExportBlock() {
	return exportBlock;
    }
    
    /** To set the domainExpression. Note assumes that the domain expression
     * has been typechecked and resolved to type facet
     * @param expressionIn The SOM_Expression object to be set
     * @return void
     */
    public void setDomainExpression(SOM_FacetExpression expressionIn) 
    {
    	domainExpression = expressionIn;
    }
    
    /** Method to get the domain expression
     * @param void
     * @ return SOM_FacetExpression
     */
    public SOM_FacetExpression getDomainExpression()
    {
    	return domainExpression;
    }
    
    
    /** To get the parentDeclList
     * @return SOM_DeclarationList that is the parentDeclList
     */
    public SOM_DeclarationList getParentDeclarationList() {
	return parentDeclList;
    }
    
    /** To set the interactionBody
     * @param bodyIn The SOM_InteractionBody to be set
     * @return void
     */
    public void setInteractionBody(SOM_InteractionBody bodyIn) {
	interactionBody = bodyIn;
    }
    
    /** To get the interactionBody
     * @return The SOM_InteractionBody of this interaction definition
     */
    public SOM_InteractionBody getInteractionBody() {
	return interactionBody;
    }
    
    /** The publishSOM routine for this class
     * @return void
     */
    public void publishSOM(PrintWriter pw) {
	if (declBlock != null) {
	    declBlock.publishSOM(pw);
	}
	if (exportBlock != null) {
	    exportBlock.publishSOM(pw);
	}
	pw.print("BEGIN ");
	if (domainExpression != null) {
	domainExpression.publishSOM(pw);
	pw.println();
	} 
	else 
	    {
		pw.println("interaction ");
	    }
	if (interactionBody != null) {
	    interactionBody.publishSOM(pw);
	}
	pw.print("END ");
    }
}


