//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_Label.java,v 1.5 2000/04/28 19:34:07 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_Label.java,v $
//  Revision 1.5  2000/04/28 19:34:07  cvs
//  Added some more of typechecking. Added parsing of the $ operator and constant literal.
//  -- Cindy
//
//  Revision 1.4  2000/03/23 00:22:48  cvs
//  Huge commit! Added all the essential accessor methods for the following classes
//  - Krishna and Makarand
//
//  Revision 1.3  2000/02/10 00:37:23  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.2  2000/02/08 18:42:34  cvs
//  Completed populating the object model and publishing the object model.
//  Added 'publishSOM(PrintWriter)' method to all necessary classes (with the help
//  of Makarand and Srini). Removed some unnecessary classes (due to changes
//  brought to the grammar). Renamed SOM_EqualityOperator to
//  SOM_EqualEqualOperator. Modified SldlParser.jj.h to populate the object model.
//  -- Cindy.
//
//  Revision 1.1  1999/10/27 20:43:41  cvs
//  The huge commit - shifting the sldl-lrm archive from uc to kansas. The
//  SldlParser.jj still has holes - but committing it anyway.
//
//  Revision 1.1  1999/10/20 21:50:43  rkamath
//  The HUGE commit (moving from my personal archive to the "kbse" archive)
//  before it moves to Kansas...
//  These files will have the log-info from my archive; they can be ignored.
//  Work on this can start afresh once all the files are in place
//  The src/SldlParser.jj.pre has "holes" - but committing it anyway
//
//  Revision 1.3  1999/07/16 21:50:31  rkamath
//  Changed everyexpression to point to the type declaration instead of having
//  a private variable which would indicate the resulting type
//
//  Revision 1.2  1999/06/30 22:20:08  rkamath
//  Compeleted the object model coding for the expression grammar
//  The expression objects now inherit from a AbstractExpression class
//
//  Revision 1.1  1999/06/27 17:33:32  rkamath
//  Added some of the object model for the Expression grammar and a few changes to
//  the other files..
//
//
//=============================================================================
package SOM;

import java.io.PrintWriter;

/** This represents the <B>Label</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_Label
extends SOM_BaseClass {
	// Note that SOM_Label does NOT extend SOM_Identifier. This arose out of a
	// consideration of the parseOrderList

	SOM_Identifier id;

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_Label() {
		super();
	}

	/** To get the string representation of this object
	 * @return String representation of this SOM_Label
	 */
	public String toString() {
		return id.toString();		
	}

	/** To get the identifier
	 * @return The SOM_Identifier corresponding to the identifier
	 */
	public SOM_Identifier getIdentifier() {
		return id;
	}

	/** To set the identifer
	 * @param idIn The SOM_Identifier to be set
	 * @return void
	 */
	public void setIdentifier(SOM_Identifier idIn) {
		id = idIn;
	}

	/** publishSOM routine needed to print the object module
     * @return void
     */
    public void publishSOM(PrintWriter pw){
        id.publishSOM(pw);
		pw.print(": ");
    }
}
