//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Krishna  krishna@ittc.ukans.edu
//
//  $Id: SOM_LetDeclarationStatementList.java,v 1.1 2000/02/10 03:56:28 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_LetDeclarationStatementList.java,v $
//  Revision 1.1  2000/02/10 03:56:28  cvs
//  Modified the grammar for incorporating records, tuples and "let" expressions. Also populated the object model with these above constructs, and completed the pretty printing for them.
//  - krishna
//
//
//
//=============================================================================
package SOM;

/** This represents the <B>LetDeclarationStatementList</B> object
 * @author <I>Krishna Ranganathan</I> (krishna@ittc.ukans.edu)
 * @see SOM.SOM_List
 * @see SOM.SOM_LetDeclarationStatement
 */
public class SOM_LetDeclarationStatementList
extends SOM_List{

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_LetDeclarationStatementList() {
		super();
	}

	/** The Second Constructor
	 * @param letDeclStmt The first SOM_LetDeclarationStatement object to be added
	 * @return Not applicable
	 */
	public SOM_LetDeclarationStatementList(SOM_LetDeclarationStatement letDeclStmt) {
		super(letDeclStmt);
	}

	/** To add a SOM_LetDeclarationStatement to the list
	 * @param letDeclStmt The SOM_LetDeclarationStatement object to be added
	 * @return void
	 */
	public void addElement(SOM_LetDeclarationStatement letDeclStmt) {
		super.addElement(letDeclStmt);
	}
}
