//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_List.java,v 1.4 2000/03/03 18:38:29 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_List.java,v $
//  Revision 1.4  2000/03/03 18:38:29  cvs
//  Seriliazing and deserializing the object model - makarand
//
//  Revision 1.3  2000/02/10 00:37:25  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.2  1999/11/13 20:01:27  cvs
//  Changed to the new OM and grammar. Some more features are to be added
//  and many bugs to be corrected. This is a commit for record and it compiles
//
//  Revision 1.1  1999/10/27 20:43:42  cvs
//  The huge commit - shifting the sldl-lrm archive from uc to kansas. The
//  SldlParser.jj still has holes - but committing it anyway.
//
//  Revision 1.1  1999/10/20 21:50:53  rkamath
//  The HUGE commit (moving from my personal archive to the "kbse" archive)
//  before it moves to Kansas...
//  These files will have the log-info from my archive; they can be ignored.
//  Work on this can start afresh once all the files are in place
//  The src/SldlParser.jj.pre has "holes" - but committing it anyway
//
//  Revision 1.10  1999/07/13 19:29:08  rkamath
//  Moved the List and ListEnumeration code to a new util directory
//  Mode the operators as children of AbstractExpression
//  Introduced the FunctionDeclaration and made OperatorDeclaration its child
//
//
//=============================================================================
package SOM;

import util.List;
import java.io.*;

/** This represents the <B>SOM_List</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
// made serializable by makarand 

public class SOM_List
extends List implements Serializable {

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_List() {
		super();
	}

	/** The Second Constructor
	 * @param data The SOM_BaseClass to be stored first
	 * @return Not applicable
	 */
	public SOM_List(SOM_BaseClass data) {
		super(data);
	}

	/** Override the addElement in List
	 * @param data The SOM_BaseClass to be added
	 * @return void
	 */
	public void addElement(SOM_BaseClass data) {
		super.addElement(data);
	}

	/** Override the removeElement in List
	 * @param data The SOM_BaseClass to be removed
	 * @return void
	 */
	public void removeElement(SOM_BaseClass data) {
		super.removeElement(data);
	}
}
