//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//
//  $Id: SOM_MethodNotSupportedException.java,v 1.2 2000/02/10 00:37:25 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_MethodNotSupportedException.java,v $
//  Revision 1.2  2000/02/10 00:37:25  cvs
//  Changed Copyright information to University of Kansas
//  - by makarand
//
//  Revision 1.1  1999/10/27 20:43:43  cvs
//  The huge commit - shifting the sldl-lrm archive from uc to kansas. The
//  SldlParser.jj still has holes - but committing it anyway.
//
//  Revision 1.1  1999/10/20 21:50:57  rkamath
//  The HUGE commit (moving from my personal archive to the "kbse" archive)
//  before it moves to Kansas...
//  These files will have the log-info from my archive; they can be ignored.
//  Work on this can start afresh once all the files are in place
//  The src/SldlParser.jj.pre has "holes" - but committing it anyway
//
//  Revision 1.1  1999/07/10 21:31:25  rkamath
//  The commit for today. Introduced a toString() function in SOM_Declaration that
//  will be used to hash "declarations" into the symboltable
//
//
//=============================================================================
package SOM;

import java.lang.RuntimeException;

/** This is the <B>MethodNotSupportedException</B> object
 * @author <I>Roshan Kamath</I> (rkamath@ececs.uc.edu)
 */
public class SOM_MethodNotSupportedException
extends RuntimeException {
	
	/** The primary constructor
	 * @return Not applicable
	 */
	public SOM_MethodNotSupportedException() {
		super();
	}

	/** The second constructor
	 * @param msg The String that is to be set as message
	 * @return Not applicable
	 */
	public SOM_MethodNotSupportedException(String msg) {
		super(msg);
	}
}
