package SOM;

import util.ListEnumeration;

import java.io.PrintWriter;

/** This represents the <B>ObserverListing</B> object
 * @author <I>Brandon Morel</I> (morel@ittc.ku.edu)
 */
public class SOM_ObserverListing
    extends SOM_BaseClass{

    private SOM_ObserverItemList observerList = new SOM_ObserverItemList();

    /** The primary Constructor
     * @return Not applicable
     */
    public SOM_ObserverListing() {
	super();
    }

    /** The secondary Constructor
     * @return Not applicable
     * @param constListType The SOM_TypeDeclaration to type the parent constructor
     */
    public SOM_ObserverListing(SOM_TypeDeclaration constListType) {
  	super();
  	observerList = new SOM_ObserverItemList(constListType);
    }

    /** To add to the observerItemList
     * @param item The SOM_ObserverItem to be added
     * @return void
     */
    public void addToObserverItemList(SOM_ObserverItem item) {
	observerList.addElement(item);
    }

    /** To retrieve the listEnumeration of the observerItemList
     * @return The ListEnumeration corresponding to the observerItemList
     */
    public ListEnumeration observers() {
	return observerList.elements();
    }
    
    /** To get the size of the list associated with the listing
     * @return The size of the list
     */
    public int size() {
	return observerList.size();
    }

    /** The publishSOM routine for this class
     * @return void
     */
    public void publishSOM(PrintWriter pw) {
	ListEnumeration observerItemEnum = observers();
	SOM_ObserverItem observerItem;

	pw.print("( ");
	((SOM_ObserverItem)observerItemEnum.nextElement()).publishSOM(pw);
	while (observerItemEnum.hasMoreElements()) {
	    pw.print(", ");
	    observerItem = (SOM_ObserverItem) observerItemEnum.nextElement(); 
	    observerItem.publishSOM(pw);
	}
	pw.print(") ");
    }	

    /** added by makarand Mar 8 2000
     *  PublishPVS routine used for SOCCER
     *  @return void
     */
    
    public void publishPVS(PrintWriter pw,SOM_List prelist, SOM_List inplist, SOM_List outlist) {
	
    }
}

