//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Krishna  krishna@ittc.ukans.edu
//
//  $Id: SOM_PackageDeclarativeItemList.java,v 1.1 2000/02/13 01:15:56 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_PackageDeclarativeItemList.java,v $
//  Revision 1.1  2000/02/13 01:15:56  cvs
//  Completed the implementation for package declarations, and the "use" clause.
//  Modified the grammar to incorporate these changes. Also populated the object
//  model with these new objects and completed the pretty-printing for these new
//  constructs.
//  Also modified the parser to now recognize the keyword "type" as a type.
//  These above changes have been compiled and tested successfully.
//  - Krishna.
//
//
//
//=============================================================================
package SOM;

/** This represents the <B>PackageDeclarativeItemList</B> object
 * @author <I>Krishna Ranganathan</I> (krishna@ittc.ukans.edu)
 */
public class SOM_PackageDeclarativeItemList
extends SOM_List{

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_PackageDeclarativeItemList() {
		super();
	}

	/** The Second Constructor
	 * @param itemIn The first SOM_PackageDeclarativeItem object to be added
	 * @return Not applicable
	 */
	public SOM_PackageDeclarativeItemList(SOM_PackageDeclarativeItem itemIn) {
		super((SOM_BaseClass)itemIn);
	}

	/** To add a SOM_PackageDeclarativeItem to the list
	 * @param itemIn The SOM_PackageDeclarativeItem object to be added
	 * @return void
	 */
	public void addElement(SOM_PackageDeclarativeItem itemIn) {
		super.addElement((SOM_BaseClass)itemIn);
	}
}
