//============================================================================
//  Copyright (c) 2000 University of Kansas 
//  All rights reserved.
//
//  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
//  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
//  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
//  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//
//
//  By using or copying this Software, Licensee agrees to abide by the
//  intellectual property laws, and all other applicable laws of the
//  U.S., and the terms of this license.
//
//	authors: Roshan rkamath@ececs.uc.edu
//           Cindy ckong@ittc.ukans.edu
//
//  $Id: SOM_TermExpressionTail.java,v 1.7 2001/03/12 23:54:39 cvs Exp $
//
//  Revision History:
//  ----------------
//  $Log: SOM_TermExpressionTail.java,v $
//  Revision 1.7  2001/03/12 23:54:39  cvs
//  Changed the order of precedence of the "=" operator. It now has lowest
//  precedence of all operators except for the "==" operator. Added some
//  type checking for facet expressions and as a result, domain names have
//  to be legal facet names. Removed several bugs as well.
//  -- Cindy
//
//  Revision 1.6  2000/08/01 22:48:57  cvs
//  added publishPVS templates in each of the expression subclasses.
//  Currently SOCCER supports PVS translation of "%" and "-" unary operator,
//  other translations can be done in these publishPVS templates as and when
//  needed - makarand.
//
//  Revision 1.5  2000/03/23 00:22:50  cvs
//  Huge commit! Added all the essential accessor methods for the
//  following classes 
//  - Krishna and Makarand
//
//
//
//=============================================================================
package SOM;

import java.io.PrintWriter;

/** This represents the <B>TermExpressionTail</B> object
 * @author <I>Roshan Kamath and Cindy Kong</I> (rkamath@ececs.uc.edu, ckong@ittc.ukans.edu)
 */
public class SOM_TermExpressionTail
extends SOM_AbstractExpressionTail {

	/** The primary Constructor
	 * @return Not applicable
	 */
	public SOM_TermExpressionTail() {
		super();
	}

	/** To set the operator
	 * @param opIn The SOM_DyadicOperator to be set
	 * @return void
	 */
	public void setOperator(SOM_DyadicOperator opIn) {
		super.setOperator(opIn);
	}

	/** To get the operator
	 * @return The SOM_DyadicOperator for this expression
	 */
	public SOM_DyadicOperator getOperator() {
		return super.getOperator();
	}

	/** To set the ImpliesExpression
	 * @param impliesExpIn  The SOM_ImpliesExpression to be set
	 * @return void
	 */
		public void setImpliesExpression(SOM_ImpliesExpression impliesExpIn) {
			setExpression((SOM_AbstractExpression)impliesExpIn);
		}

	/** To get the impliesExpression
	 * @return The SOM_ImpliesExpression  for this expression
	 */
	public SOM_ImpliesExpression getImpliesExpression() {
		return (SOM_ImpliesExpression)getExpression();
	}

	/** The publishSOM routine for this class
	 * @return void
	 */
	public void publishSOM(PrintWriter pw) {
		super.getOperator().publishSOM(pw);
		getExpression().publishSOM(pw);
	}

		/** The publishPVS routine for this class
		 * @return void
		 */
		public void publishPVS(PrintWriter pw) {
				super.getOperator().publishPVS(pw);
				getExpression().publishPVS(pw);
		}
}
