#!/usr/bin/perl
#============================================================================
#  Copyright (c) 2000 University of Kansas 
#  All rights reserved.
#
#  KU MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
#  THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
#  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
#  PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  KU SHALL NOT BE LIABLE
#  FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
#  MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
#
#
#  By using or copying this Software, Licensee agrees to abide by the
#  intellectual property laws, and all other applicable laws of the
#  U.S., and the terms of this license.
#
#	authors: Srinivas (akki@ittc.ukans.edu)
#
#  $Id: test.pl,v 1.2 2000/03/07 00:48:54 cvs Exp $
#
#  Revision History:
#  ----------------
#  $Log: test.pl,v $
#  Revision 1.2  2000/03/07 00:48:54  cvs
#  Changing the user id to sldg group so that everyone receives the mail
#  --srinivas
#
#  Revision 1.1  2000/03/07 00:42:15  cvs
#  The script that runs the regression tests daily .It has the following options
#  	-do_update
#  	-force_update
#  	-query_update
#  	--srinivas
#
#
#
#=============================================================================
#
# Global flags
#
use Cwd;
$updateExpected = "false";
         
#
# Process Arguments
#      
@ARGV = ('-') unless @ARGV;
while($ARGV = shift){
    if($ARGV =~ /-force_update/){
        $updateExpected = "force";
    } elsif($ARGV =~ /-query_update/){
        $updateExpected = "query";
    } elsif ($ARGV =~ /-do_update/){
        $updateExpected = "do";
        }
}

chdir ("/projects/sldg/projects/unstable");
$s1 = system ('cvs -d /projects/sldg/CVS update -d');
chdir ("/projects/sldg/projects/unstable/sldl-lrm/grammar/src") or die
"sorry";
$s2 = system ('make clean');
$s3 =system ('make all');
chdir ("/projects/sldg/projects/unstable/sldl-lrm/grammar/test") or die
"sorry" ;
if ($updateExpected eq "false"){
$s4 = system ('perl sldltest.pl ');
}elsif ($updateExpected eq "force"){
$s4 = system ('perl sldltest.pl -force_update');
}elsif ($updateExpected eq "query"){
$s4 = system ('perl sldltest.pl -query_update');
}elsif ($updateExpected eq "do"){
$s4 = system ('perl sldltest.pl -do_update');
}
$s5 = system ('mail  -s testresults sldg,sldgu < test.results');

 
